#include "file_editor.h"

void ColorChanged_default(GtkWidget *widget, GtkColorSelectionDialog *colorseldlg)
{
  gdouble color[3];

  gtk_color_selection_get_color ((GtkColorSelection *)GTK_COLOR_SELECTION_DIALOG(colorseldlg)->colorsel, color);
  color_tab[11]->red   = (guint16)(color[0]*65535.0);
  color_tab[11]->green = (guint16)(color[1]*65535.0);
  color_tab[11]->blue  = (guint16)(color[2]*65535.0);
  gtk_editor_set_pattern_property((GtkEditor *)editor, "default", font, color_tab[11], NULL);
  gtk_editor_hilite_buffer ((GtkEditor *)editor);
  gtk_widget_destroy(GTK_WIDGET(colorseldlg));
}

void ColorChanged_comment(GtkWidget *widget, GtkColorSelectionDialog *colorseldlg)
{
  gdouble color[3];

  gtk_color_selection_get_color ((GtkColorSelection *)GTK_COLOR_SELECTION_DIALOG(colorseldlg)->colorsel,color);
  color_tab[3]->red   = (guint16)(color[0]*65535.0);
  color_tab[3]->green = (guint16)(color[1]*65535.0);
  color_tab[3]->blue  = (guint16)(color[2]*65535.0);
  gtk_editor_set_pattern_property((GtkEditor *)editor, "comment", font, color_tab[3], NULL);
  gtk_editor_hilite_buffer ((GtkEditor *)editor);
  gtk_widget_destroy(GTK_WIDGET(colorseldlg));
}

void ColorChanged_include(GtkWidget *widget, GtkColorSelectionDialog *colorseldlg)
{
  gdouble color[3];

  gtk_color_selection_get_color ((GtkColorSelection *)GTK_COLOR_SELECTION_DIALOG(colorseldlg)->colorsel,color);
  color_tab[0]->red   = (guint16)(color[0]*65535.0);
  color_tab[0]->green = (guint16)(color[1]*65535.0);
  color_tab[0]->blue  = (guint16)(color[2]*65535.0);
  gtk_editor_set_pattern_property((GtkEditor *)editor, "include", font, color_tab[0], NULL);
  gtk_editor_hilite_buffer ((GtkEditor *)editor);
  gtk_widget_destroy(GTK_WIDGET(colorseldlg));
}

void ColorChanged_declare(GtkWidget *widget, GtkColorSelectionDialog *colorseldlg)
{
  gdouble color[3];

  gtk_color_selection_get_color ((GtkColorSelection *)GTK_COLOR_SELECTION_DIALOG(colorseldlg)->colorsel,color);

  color_tab[1]->red   = (guint16)(color[0]*65535.0);
  color_tab[1]->green = (guint16)(color[1]*65535.0);
  color_tab[1]->blue  = (guint16)(color[2]*65535.0);
  gtk_editor_set_pattern_property((GtkEditor *)editor, "declare", font, color_tab[1], NULL);
  gtk_editor_hilite_buffer ((GtkEditor *)editor);
  gtk_widget_destroy(GTK_WIDGET(colorseldlg));
}

void ColorChanged_base(GtkWidget *widget, GtkColorSelectionDialog *colorseldlg)
{
  gdouble color[3];

  gtk_color_selection_get_color ((GtkColorSelection *)GTK_COLOR_SELECTION_DIALOG(colorseldlg)->colorsel,color);
  color_tab[2]->red   = (guint16)(color[0]*65535.0);
  color_tab[2]->green = (guint16)(color[1]*65535.0);
  color_tab[2]->blue  = (guint16)(color[2]*65535.0);
  gtk_editor_set_pattern_property((GtkEditor *)editor, "base", font, color_tab[2], NULL);
  gtk_editor_hilite_buffer ((GtkEditor *)editor);
  gtk_widget_destroy(GTK_WIDGET(colorseldlg));
}

void ColorChanged_objet(GtkWidget *widget, GtkColorSelectionDialog *colorseldlg)
{
  gdouble color[3];

  gtk_color_selection_get_color ((GtkColorSelection *)GTK_COLOR_SELECTION_DIALOG(colorseldlg)->colorsel,color);
  color_tab[5]->red   = (guint16)(color[0]*65535.0);
  color_tab[5]->green = (guint16)(color[1]*65535.0);
  color_tab[5]->blue  = (guint16)(color[2]*65535.0);
  gtk_editor_set_pattern_property((GtkEditor *)editor, "objet", font, color_tab[5], NULL);
  gtk_editor_hilite_buffer ((GtkEditor *)editor);
  gtk_widget_destroy(GTK_WIDGET(colorseldlg));
}

void ColorChanged_operation(GtkWidget *widget, GtkColorSelectionDialog *colorseldlg)
{
  gdouble color[3];

  gtk_color_selection_get_color ((GtkColorSelection *)GTK_COLOR_SELECTION_DIALOG(colorseldlg)->colorsel,color);

  color_tab[6]->red   = (guint16)(color[0]*65535.0);
  color_tab[6]->green = (guint16)(color[1]*65535.0);
  color_tab[6]->blue  = (guint16)(color[2]*65535.0);
  gtk_editor_set_pattern_property((GtkEditor *)editor, "operation", font, color_tab[6], NULL);
  gtk_editor_hilite_buffer ((GtkEditor *)editor);
  gtk_widget_destroy(GTK_WIDGET(colorseldlg));
}

void ColorChanged_texture(GtkWidget *widget, GtkColorSelectionDialog *colorseldlg)
{
  gdouble color[3];

  gtk_color_selection_get_color ((GtkColorSelection *)GTK_COLOR_SELECTION_DIALOG(colorseldlg)->colorsel,color);

  color_tab[9]->red   = (guint16)(color[0]*65535.0);
  color_tab[9]->green = (guint16)(color[1]*65535.0);
  color_tab[9]->blue  = (guint16)(color[2]*65535.0);
  gtk_editor_set_pattern_property((GtkEditor *)editor, "texture", font, color_tab[9], NULL);
  gtk_editor_hilite_buffer ((GtkEditor *)editor);
  gtk_widget_destroy(GTK_WIDGET(colorseldlg));
}

void ColorChanged_transfo(GtkWidget *widget, GtkColorSelectionDialog *colorseldlg)
{
  gdouble color[3];

  gtk_color_selection_get_color ((GtkColorSelection *)GTK_COLOR_SELECTION_DIALOG(colorseldlg)->colorsel,color);
  color_tab[8]->red   = (guint16)(color[0]*65535.0);
  color_tab[8]->green = (guint16)(color[1]*65535.0);
  color_tab[8]->blue  = (guint16)(color[2]*65535.0);
  gtk_editor_set_pattern_property((GtkEditor *)editor, "transformation", font, color_tab[8], NULL);
  gtk_editor_hilite_buffer ((GtkEditor *)editor);
  gtk_widget_destroy(GTK_WIDGET(colorseldlg));
}

void ColorChanged_constant(GtkWidget *widget, GtkColorSelectionDialog *colorseldlg)
{
  gdouble color[3];

  gtk_color_selection_get_color ((GtkColorSelection *)GTK_COLOR_SELECTION_DIALOG(colorseldlg)->colorsel,color);
  color_tab[10]->red   = (guint16)(color[0]*65535.0);
  color_tab[10]->green = (guint16)(color[1]*65535.0);
  color_tab[10]->blue  = (guint16)(color[2]*65535.0);
  gtk_editor_set_pattern_property((GtkEditor *)editor, "constant", font, color_tab[10], NULL);
  gtk_editor_hilite_buffer ((GtkEditor *)editor);
  gtk_widget_destroy(GTK_WIDGET(colorseldlg));
}

void ColorChanged_operator(GtkWidget *widget, GtkColorSelectionDialog *colorseldlg)
{
  gdouble color[3];

  gtk_color_selection_get_color ((GtkColorSelection *)GTK_COLOR_SELECTION_DIALOG(colorseldlg)->colorsel,color);

  color_tab[7]->red   = (guint16)(color[0]*65535.0);
  color_tab[7]->green = (guint16)(color[1]*65535.0);
  color_tab[7]->blue  = (guint16)(color[2]*65535.0);
  gtk_editor_set_pattern_property((GtkEditor *)editor, "operator", font, color_tab[7], NULL);
  gtk_editor_hilite_buffer ((GtkEditor *)editor);
  gtk_widget_destroy(GTK_WIDGET(colorseldlg));
}

void ColorChanged_separator(GtkWidget *widget, GtkColorSelectionDialog *colorseldlg)
{
  gdouble color[3];

  gtk_color_selection_get_color ((GtkColorSelection *)GTK_COLOR_SELECTION_DIALOG(colorseldlg)->colorsel,color);
  color_tab[4]->red   = (guint16)(color[0]*65535.0);
  color_tab[4]->green = (guint16)(color[1]*65535.0);
  color_tab[4]->blue  = (guint16)(color[2]*65535.0);
  gtk_editor_set_pattern_property((GtkEditor *)editor, "separator", font, color_tab[4], NULL);
  gtk_editor_hilite_buffer ((GtkEditor *)editor);
  gtk_widget_destroy(GTK_WIDGET(colorseldlg));
}

void ChangeColor (GtkWidget *widget, int obj)
{
  GtkWidget *colorseldlg;
  gdouble   color[3];
  colorseldlg = gtk_color_selection_dialog_new("Select color text");
  
  switch (obj)
    {
    case 0:
      color[0] = color_tab[11]->red / 65535.0;
      color[1] = color_tab[11]->green / 65535.0;
      color[2] = color_tab[11]->blue / 65535.0;
      gtk_color_selection_set_color ((GtkColorSelection *)GTK_COLOR_SELECTION_DIALOG(colorseldlg)->colorsel, color);
      gtk_signal_connect(GTK_OBJECT(GTK_COLOR_SELECTION_DIALOG (colorseldlg)->ok_button), "clicked",
			 (GtkSignalFunc)ColorChanged_default, (gpointer)colorseldlg);
      break;
    case 1:
      color[0] = color_tab[3]->red / 65535.0;
      color[1] = color_tab[3]->green / 65535.0;
      color[2] = color_tab[3]->blue / 65535.0;
      gtk_color_selection_set_color ((GtkColorSelection *)GTK_COLOR_SELECTION_DIALOG(colorseldlg)->colorsel, color);
      gtk_signal_connect(GTK_OBJECT(GTK_COLOR_SELECTION_DIALOG (colorseldlg)->ok_button), "clicked",
			 (GtkSignalFunc)ColorChanged_comment, (gpointer)colorseldlg);
      break;
    case 2:
      color[0] = color_tab[0]->red / 65535.0;
      color[1] = color_tab[0]->green / 65535.0;
      color[2] = color_tab[0]->blue / 65535.0;
      gtk_color_selection_set_color ((GtkColorSelection *)GTK_COLOR_SELECTION_DIALOG(colorseldlg)->colorsel, color);
      gtk_signal_connect(GTK_OBJECT(GTK_COLOR_SELECTION_DIALOG (colorseldlg)->ok_button), "clicked",
			 (GtkSignalFunc)ColorChanged_include, (gpointer)colorseldlg);
      break;
    case 3:
      color[0] = color_tab[1]->red / 65535.0;
      color[1] = color_tab[1]->green / 65535.0;
      color[2] = color_tab[1]->blue / 65535.0;
      gtk_color_selection_set_color ((GtkColorSelection *)GTK_COLOR_SELECTION_DIALOG(colorseldlg)->colorsel, color);
      gtk_signal_connect(GTK_OBJECT(GTK_COLOR_SELECTION_DIALOG (colorseldlg)->ok_button), "clicked",
			 (GtkSignalFunc)ColorChanged_declare, (gpointer)colorseldlg);
      break;
    case 4:
      color[0] = color_tab[2]->red / 65535.0;
      color[1] = color_tab[2]->green / 65535.0;
      color[2] = color_tab[2]->blue / 65535.0;
      gtk_color_selection_set_color ((GtkColorSelection *)GTK_COLOR_SELECTION_DIALOG(colorseldlg)->colorsel, color);
      gtk_signal_connect(GTK_OBJECT(GTK_COLOR_SELECTION_DIALOG (colorseldlg)->ok_button), "clicked",
			 (GtkSignalFunc)ColorChanged_base,    (gpointer)colorseldlg);
      break;
    case 5:
      color[0] = color_tab[5]->red / 65535.0;
      color[1] = color_tab[5]->green / 65535.0;
      color[2] = color_tab[5]->blue / 65535.0;
      gtk_color_selection_set_color ((GtkColorSelection *)GTK_COLOR_SELECTION_DIALOG(colorseldlg)->colorsel, color);
      gtk_signal_connect(GTK_OBJECT(GTK_COLOR_SELECTION_DIALOG (colorseldlg)->ok_button), "clicked",
			 (GtkSignalFunc)ColorChanged_objet,   (gpointer)colorseldlg);
      break;
    case 6:
      color[0] = color_tab[6]->red / 65535.0;
      color[1] = color_tab[6]->green / 65535.0;
      color[2] = color_tab[6]->blue / 65535.0;
      gtk_color_selection_set_color ((GtkColorSelection *)GTK_COLOR_SELECTION_DIALOG(colorseldlg)->colorsel, color);
      gtk_signal_connect(GTK_OBJECT(GTK_COLOR_SELECTION_DIALOG (colorseldlg)->ok_button), "clicked",
			 (GtkSignalFunc)ColorChanged_operation, (gpointer)colorseldlg);
      break;
    case 7:
      color[0] = color_tab[9]->red / 65535.0;
      color[1] = color_tab[9]->green / 65535.0;
      color[2] = color_tab[9]->blue / 65535.0;
      gtk_color_selection_set_color ((GtkColorSelection *)GTK_COLOR_SELECTION_DIALOG(colorseldlg)->colorsel, color);
      gtk_signal_connect(GTK_OBJECT(GTK_COLOR_SELECTION_DIALOG (colorseldlg)->ok_button), "clicked",
			 (GtkSignalFunc)ColorChanged_texture, (gpointer)colorseldlg);
      break;
    case 8:
      color[0] = color_tab[8]->red / 65535.0;
      color[1] = color_tab[8]->green / 65535.0;
      color[2] = color_tab[8]->blue / 65535.0;
      gtk_color_selection_set_color ((GtkColorSelection *)GTK_COLOR_SELECTION_DIALOG(colorseldlg)->colorsel, color);
      gtk_signal_connect(GTK_OBJECT(GTK_COLOR_SELECTION_DIALOG (colorseldlg)->ok_button), "clicked",
			 (GtkSignalFunc)ColorChanged_transfo, (gpointer)colorseldlg);
      break;
    case 9:
      color[0] = color_tab[10]->red / 65535.0;
      color[1] = color_tab[10]->green / 65535.0;
      color[2] = color_tab[10]->blue / 65535.0;
      gtk_color_selection_set_color ((GtkColorSelection *)GTK_COLOR_SELECTION_DIALOG(colorseldlg)->colorsel, color);
      gtk_signal_connect(GTK_OBJECT(GTK_COLOR_SELECTION_DIALOG (colorseldlg)->ok_button), "clicked",
			 (GtkSignalFunc)ColorChanged_constant, (gpointer)colorseldlg);
      break;
    case 10:
      color[0] = color_tab[7]->red / 65535.0;
      color[1] = color_tab[7]->green / 65535.0;
      color[2] = color_tab[7]->blue / 65535.0;
      gtk_color_selection_set_color ((GtkColorSelection *)GTK_COLOR_SELECTION_DIALOG(colorseldlg)->colorsel, color);
      gtk_signal_connect(GTK_OBJECT(GTK_COLOR_SELECTION_DIALOG (colorseldlg)->ok_button), "clicked",
			 (GtkSignalFunc)ColorChanged_operator, (gpointer)colorseldlg);
      break;
    case 11:
      color[0] = color_tab[4]->red / 65535.0;
      color[1] = color_tab[4]->green / 65535.0;
      color[2] = color_tab[4]->blue / 65535.0;
      gtk_color_selection_set_color ((GtkColorSelection *)GTK_COLOR_SELECTION_DIALOG(colorseldlg)->colorsel, color);
      gtk_signal_connect(GTK_OBJECT(GTK_COLOR_SELECTION_DIALOG (colorseldlg)->ok_button), "clicked",
			 (GtkSignalFunc)ColorChanged_separator, (gpointer)colorseldlg);
      break;
    } 
  gtk_signal_connect_object(GTK_OBJECT(GTK_COLOR_SELECTION_DIALOG (colorseldlg)->cancel_button), "clicked",
			 (GtkSignalFunc)gtk_widget_destroy, GTK_OBJECT(colorseldlg));
  gtk_widget_show(colorseldlg);
}








