#include "file_editor.h"

guint     key1  = 0;
guint     key2  = 0;
guint     key3  = 0;

gint EditorEventHelp(GtkWidget *window, GdkEvent *event, 
		 gpointer Menu)
{ 
  switch (event->type)
    {
    case GDK_KEY_PRESS:
      {
        GdkEventKey *bevent = (GdkEventKey *) event;
        if (bevent->keyval == 65307) /* escape */
	  {
	    gtk_widget_destroy (window);
	    gtk_entry_set_text (GTK_ENTRY(entry), "");
	  }
        return TRUE;
      }
    default:
      return FALSE;
    }
}

gint EditorEvent(GtkWidget *window, GdkEvent *event, 
		 gpointer Menu)
{ 
  switch (event->type)
    {
    case GDK_BUTTON_PRESS:
      {
        GdkEventButton *bevent = (GdkEventButton *) event;
        if (bevent->button == 3) /* Right Button ==> Popup Menu */
	  {
	    gtk_menu_popup(GTK_MENU(Menu), NULL, NULL, NULL, NULL,
			   bevent->button, bevent->time);
	  }
        return TRUE;
      }
    case GDK_KEY_PRESS:
      {
	GdkEventKey *kevent = (GdkEventKey *) event;

	if (key1 == 0)
	  key1 = kevent->keyval;
	else
	  if (key2 == 0)
	    key2 = kevent->keyval;
	  else
	    if (key3 == 0)
	      key3 = kevent->keyval;
	    else
	      key1 = key2 = key3 = 0;

        if ((key1 == 65507) && (key2 == 104) && (key3 == 116)) /* C-h t */
	  {
	    HelpEdit();
	    key1 = key2 = key3 = 0;
	  }
        else 
	  if((key1 == 65507) && (key2 == 120) && (key3 == 102)) /* C-x f */
	    {
	      OpenFunc();
	      key1 = key2 = key3 = 0;
	    }
	  else 
	    if((key1 == 65507) && (key2 == 120) && (key3 == 115)) /* C-x s */
	      {
		OpenFunc2();
		key1 = key2 = key3 = 0;
	      }
	    else 
	      if((key1 == 65507) && (key2 == 120) && (key3 == 99)) /* C-x c */
		{
		  gtk_widget_destroy(window);
		  key1 = key2 =  key3 = 0;
		}
	      else 
		if((key1 == 65507) && (key2 == 120) && (key3 == 114)) /* C-x r */
		  {
		    RenderPov();
		    key1 = key2 =  key3 = 0;
		  }
		else
		  if (key1 != 65507)
		    key1 = key2 = key3 = 0;
	
	//gtk_entry_set_text (GTK_ENTRY(entry), g_strdup_printf("Ligne: %d", ligne));
      }
    default:
      return FALSE;
    }
}








