#include "file_editor.h"

int Save_Pov_Func_Edit (char *file_save)
{
  int	len;
  FILE	*fp;
  gchar *text;

  gtk_entry_set_text (GTK_ENTRY(entry), 
		      g_strconcat("Sauve le fichier: ", file_save, 0));
  len = gtk_text_get_length (GTK_TEXT(editor));
  text = gtk_editable_get_chars(GTK_EDITABLE(editor), 0, len);

  if (NULL == (fp = (fopen(file_save, "w"))))
    return -1;
  fprintf (fp, "%s", text);
  fclose(fp);
  free (file_save);
  //gtk_entry_set_text (GTK_ENTRY(entry), "");

  return 1;
}

int load_pov_file(char *file)
{
  int fp;
  char buf[256];
  int num_char;
  
  gtk_entry_set_text (GTK_ENTRY(entry), g_strconcat("Load le fichier: ", file, 0));

  gtk_text_backward_delete (GTK_TEXT(editor), gtk_text_get_length (GTK_TEXT(editor)));

  gtk_text_freeze (GTK_TEXT(editor));
  fp = open(file, O_RDONLY);
  if (fp == -1)
    return -1;
  memset(buf, 0, 256);
  while (0 <  (num_char = read(fp, buf, 256)))
    gtk_text_insert((GtkText *)editor, NULL, NULL, NULL, buf, num_char);
  gtk_editor_hilite_buffer ((GtkEditor *)editor);
  gtk_text_thaw (GTK_TEXT(editor));
  //gtk_entry_set_text (GTK_ENTRY(entry), "");
  return 1;
}

void file_ok_sel_edit (GtkWidget *widget, GtkFileSelection *fs)
{
  char *file_name = gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs));

  strcpy(CURRENT_FILE, file_name);
  load_pov_file(file_name);

  gtk_widget_destroy( GTK_WIDGET(fs) );
}

void file_ok_sel2 (GtkWidget *widget, GtkFileSelection *fs)
{
  char *file_name = gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs));

  strcpy(CURRENT_FILE, file_name);
  Save_Pov_Func_Edit(file_name);
  
  gtk_widget_destroy( GTK_WIDGET(fs) );
}

void OpenFunc (void)
{
  GtkWidget *filew;
  
  filew = gtk_file_selection_new ("Open POV file");
  
  gtk_signal_connect (GTK_OBJECT (filew), 
		      "destroy", 
		      (GtkSignalFunc) gtk_widget_destroy, 
		      GTK_OBJECT (filew));
  
  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button), 
		      "clicked", 
		      (GtkSignalFunc) file_ok_sel_edit, 
		      filew );
  
  gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (filew)->cancel_button), 
			     "clicked", 
			     (GtkSignalFunc) gtk_widget_destroy, 
			     GTK_OBJECT (filew)); 
  gtk_widget_show (filew);
}

void OpenFunc2 (void)
{
  GtkWidget *filew;
  
  filew = gtk_file_selection_new ("Save POV file");
  
  gtk_signal_connect (GTK_OBJECT (filew), 
		      "destroy", 
		      (GtkSignalFunc) gtk_widget_destroy, 
		      GTK_OBJECT (filew));
  
  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button), 
		      "clicked", 
		      (GtkSignalFunc) file_ok_sel2, 
		      filew );
  
  gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (filew)->cancel_button), 
			     "clicked", 
			     (GtkSignalFunc) gtk_widget_destroy, 
			     GTK_OBJECT (filew)); 
  gtk_widget_show (filew);
}
