/* TOOLS for SOR */
#define	SIZE_WIN_X	200
#define	SIZE_WIN_Y	300

#define drawOneLine(x1,y1,x2,y2)  glBegin(GL_LINES);  \
   glVertex2f ((x1),(y1)); glVertex2f ((x2),(y2)); glEnd();

#define NB_MENU_ON_SOR	2
#define	PT_OFFSET_X	3
#define	PT_OFFSET_Y	3


typedef struct
{
  char	*item;
  void	(*fcn)(void);
} t_menu_popup_sor;

typedef enum
{
  SOR_ADD_POINT,
  SOR_DEL_POINT,
  SOR_MOV_POINT,
  SOR_ON_MOV_POINT,
  SOR_ZOOM_IN,
  SOR_ZOOM_OUT,
  SOR_NONE
} T_mode_tool_sor;


typedef struct
{
  int		id;
  float		x;
  float		y;
}T_pt_sor;


int	CreateBox(float x, float y, float z);
int	CreateCone(float x, float y, float z);
int	CreateCylindre(float x, float y, float z);
int	CreateSphere(float x, float y, float z);
int	CreatePlane(float x, float y, float z);
int	CreateTorus(float x, float y, float z);
int	CreateTube(float x, float y, float z);
int	CreateOpenCone(float x, float y, float z);
int	CreateSor(float x, float y, float z);
