#include "headers.h"
#include "xpm/quitter.xpm"

void affiche_gestion (GtkToggleButton *button, int data)
{
  switch (data)
    {
    case 1:
      if (gtk_toggle_button_get_active    (button))
	open_windows.right_b=TRUE;
      else
	  {
	    gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (windows_view.check_a) , 0);
	    open_windows.right_b=FALSE;
	  }
      windows_openning( 1 );
      break;
    case 2:
      if (gtk_toggle_button_get_active    (button))
	open_windows.face_b=TRUE;
      else
	{
	  gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (windows_view.check_a) , 0);
	  open_windows.face_b=FALSE;
	}
      windows_openning( 2 );
      break;
    case 3:
      if (gtk_toggle_button_get_active    (button))
	open_windows.over_b=TRUE;
      else
	{
	  gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (windows_view.check_a) , 0);
	  open_windows.over_b=FALSE;
	}
      windows_openning( 3 );
      break;
    case 4:
      if (gtk_toggle_button_get_active    (button))
	open_windows.vu3d_b=TRUE;
      else
	{
	  gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (windows_view.check_a) , 0);
	  open_windows.vu3d_b=FALSE;
	}
      windows_openning( 4 );
    }
  if (open_windows.right_b && 
      open_windows.face_b && 
      open_windows.over_b && open_windows.vu3d_b)
    gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (windows_view.check_a) , 1);
}

void active_all ()
{
  if (open_windows.right_b == FALSE)
    {
      open_windows.right_b=TRUE;
      gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (windows_view.check_r) , 1);
    }
  if (open_windows.face_b == FALSE)
    {
      open_windows.face_b=TRUE;
      gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (windows_view.check_f) , 1);
    }
  if (open_windows.over_b == FALSE)
    {
      open_windows.over_b=TRUE;
      gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (windows_view.check_o) , 1);
    }
  if (open_windows.vu3d_b == FALSE)
    {
      open_windows.vu3d_b=TRUE;
      gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (windows_view.check_d) , 1);
    }  
}

void make_check (GtkWidget *table, int x_min, int x_max, int y_min, 
		 int y_max,int type_mess, gboolean toggled_button, char *label)
{
  switch ( type_mess )
    {
    case 1:
      windows_view.check_r = gtk_check_button_new_with_label (label);
      if (toggled_button)
	gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (windows_view.check_r) , 1);
      gtk_signal_connect (GTK_OBJECT (windows_view.check_r), 
			  "toggled", 
			  GTK_SIGNAL_FUNC (affiche_gestion), 
			  (gpointer) type_mess );

      gtk_table_attach (GTK_TABLE (table), 
			windows_view.check_r, 
			x_min, x_max, y_min, y_max, 
			GTK_EXPAND | GTK_FILL, 
			GTK_EXPAND | GTK_FILL, 5, 5);
      gtk_widget_show (windows_view.check_r);
    case 2:
      windows_view.check_f = gtk_check_button_new_with_label (label);
      if (toggled_button)
	gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (windows_view.check_f) , 1);
      gtk_signal_connect (GTK_OBJECT (windows_view.check_f), 
			  "toggled", 
			  GTK_SIGNAL_FUNC (affiche_gestion), 
			  (gpointer) type_mess );

      gtk_table_attach (GTK_TABLE (table), 
			windows_view.check_f, 
			x_min, x_max, y_min, y_max, 
			GTK_EXPAND | GTK_FILL, 
			GTK_EXPAND | GTK_FILL, 5, 5);
      
      gtk_widget_show (windows_view.check_f);
    case 3:
      windows_view.check_o = gtk_check_button_new_with_label (label);
      if (toggled_button)
	gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (windows_view.check_o) , 1);
      gtk_signal_connect (GTK_OBJECT (windows_view.check_o), 
			  "toggled", 
			  GTK_SIGNAL_FUNC (affiche_gestion), 
			  (gpointer) type_mess );
      
      gtk_table_attach (GTK_TABLE (table), 
			windows_view.check_o, 
			x_min, x_max, y_min, y_max, 
			GTK_EXPAND | GTK_FILL, 
			GTK_EXPAND | GTK_FILL, 5, 5);
      gtk_widget_show (windows_view.check_o);
    case 4:
      windows_view.check_d = gtk_check_button_new_with_label (label);
      if (toggled_button)
	gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (windows_view.check_d) , 1);
      gtk_signal_connect (GTK_OBJECT (windows_view.check_d), 
			  "toggled", 
			  GTK_SIGNAL_FUNC (affiche_gestion), 
			  (gpointer) type_mess );
      gtk_table_attach (GTK_TABLE (table), 
			windows_view.check_d, 
			x_min, x_max, y_min, y_max, 
			GTK_EXPAND | GTK_FILL, 
			GTK_EXPAND | GTK_FILL, 5, 5);
      gtk_widget_show (windows_view.check_d);
    }
}

void window_gestion ( GtkNotebook *notebook )
{
  GtkWidget *frame;
  GtkWidget *label;
  GtkWidget *vbox;
  GtkWidget *table;
  char bufferl[32];
  int right=1;
  int face=2;
  int over=3;
  int vu3d=4;

  sprintf(bufferl, "Fentres");
  frame = gtk_frame_new ("Gestion des fentres");
  gtk_container_set_border_width (GTK_CONTAINER (frame), 0);
  gtk_widget_show (frame);

  vbox=gtk_vbox_new ( FALSE,1);
  gtk_container_add (GTK_CONTAINER (frame), vbox);
  gtk_widget_show(vbox);
  
  table = gtk_table_new (4, 2, FALSE);
  gtk_container_add (GTK_CONTAINER (vbox), table);
  
  make_check(table, 0, 1, 0, 1, right, open_windows.right_b, "Vue de droite");   
  make_check(table, 0, 1, 1, 2, face, open_windows.face_b, "Vue de face");
  make_check(table, 0, 1, 2, 3, over, open_windows.over_b, "Vue de dessus");
  make_check(table, 0, 1, 3, 4, vu3d, open_windows.vu3d_b, "Vue 3D");

  windows_view.check_a = gtk_check_button_new_with_label ("Toutes les fenetres actives");

  if (open_windows.right_b && 
      open_windows.face_b && 
      open_windows.over_b && 
      open_windows.vu3d_b)
    
    gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (windows_view.check_a) , 1);
  else
    gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (windows_view.check_a) , 0);
  gtk_signal_connect (GTK_OBJECT (windows_view.check_a), 
		      "toggled", 
		      GTK_SIGNAL_FUNC (active_all), 
		      NULL );
  
  gtk_table_attach (GTK_TABLE (table), 
		    windows_view.check_a, 1, 2, 0, 1, 
		    GTK_EXPAND | GTK_FILL, 
		    GTK_EXPAND | GTK_FILL, 5, 5);

  gtk_widget_show (windows_view.check_a);
  gtk_widget_show(table);

  label = gtk_label_new (bufferl);
  gtk_notebook_append_page (GTK_NOTEBOOK (notebook), frame, label);

}

void change_text(GtkWidget *text)
{
  strcpy(conf_user.default_path,gtk_editable_get_chars ( GTK_EDITABLE (text), 0, -1));
}

void change_active(GtkWidget *check)
{
  conf_user.start_window_b=gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(check));
}

void option_general ( GtkNotebook *notebook)
{
  
  GtkWidget *frame;
  GtkWidget *check;
  GtkWidget *label;
  GtkWidget *table;
  GtkWidget *text;
  GdkFont *font;
  
  font=gdk_font_load("-urw-helvetica narrow-medium-r-condensed--17-160-75-75-p-74-iso8859-1");

  frame = gtk_frame_new ("Options gnrales");
  gtk_container_set_border_width (GTK_CONTAINER (frame), 0);
  gtk_widget_show (frame);

  table = gtk_table_new (5, 3, FALSE);
  gtk_container_add (GTK_CONTAINER (frame), table);
  label = gtk_label_new ("Chemin par dfaut pour l'enregistrement:");
  gtk_table_attach (GTK_TABLE (table), 
		    label, 0, 2, 0, 1, 
		    GTK_EXPAND | GTK_FILL, 
		    GTK_EXPAND  | GTK_FILL, 1, 5);
  gtk_widget_show (label);
  
  text = gtk_entry_new ();
  gtk_entry_set_text ( GTK_ENTRY (text), conf_user.default_path);
  gtk_signal_connect_object (GTK_OBJECT (text), 
			     "changed", 
			     GTK_SIGNAL_FUNC (change_text), 
			     GTK_OBJECT(text));
  
  gtk_table_attach (GTK_TABLE (table), 
		    text, 0, 3, 1, 2, 
		    GTK_EXPAND | GTK_FILL, 
		    GTK_EXPAND| GTK_FILL, 20, 5);
  gtk_widget_show (text);

  label = gtk_label_new ("Activation choix des vues au dmarage");
  gtk_table_attach (GTK_TABLE (table), 
		    label, 0, 2, 2, 3, 
		    GTK_EXPAND | GTK_FILL , 
		    GTK_EXPAND | GTK_FILL, 1, 5);
  gtk_widget_show (label);

  check = gtk_check_button_new_with_label ( "(baisser=Activer,lever=Desactiver)" );
  if (conf_user.start_window_b)
   gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (check) , 1); 
  gtk_signal_connect (GTK_OBJECT (check), 
		      "toggled", 
		      GTK_SIGNAL_FUNC (change_active), 
		      check);
  gtk_table_attach (GTK_TABLE (table), 
		    check, 0, 3, 3, 4, 
		    GTK_EXPAND | GTK_FILL, 
		    GTK_EXPAND | GTK_FILL, 20, 5);
  gtk_widget_show (check);
  
  
  /*    button = gtk_button_new (); */
  /*    gtk_signal_connect_object (GTK_OBJECT (button),  */
  /*  			     "clicked",  */
  /*  			     GTK_SIGNAL_FUNC (bouton_appliquer),); */
  /*    hbox = gtk_hbox_new(FALSE, 1); */
  /*    gtk_container_add(GTK_CONTAINER(button), hbox); */
  /*    gtk_widget_show(hbox); */
  /*    gdk_pixmap = gdk_pixmap_create_from_xpm_d(NULL, &mask, &transparent, ok_xpm); */
  /*    pixmap = gtk_pixmap_new(gdk_pixmap, mask); */
  /*    gdk_pixmap_unref(gdk_pixmap); */
  /*    gtk_box_pack_start(GTK_BOX(hbox), pixmap, 1, 0, 4); */
  /*    gtk_widget_show(pixmap); */
  /*    label = gtk_label_new("APPLIQUER"); */
  /*    gtk_box_pack_start(GTK_BOX(hbox), label, 1, 0, 0); */
  /*    gtk_widget_show(label); */
  /*    gtk_table_attach (GTK_TABLE(table), button, 2,3,4,5, GTK_SHRINK, GTK_SHRINK, 5,5); */
  /*    gtk_widget_show(button); */


  gtk_widget_show(table);
  label = gtk_label_new ("Gnrales");
  gtk_notebook_append_page (GTK_NOTEBOOK (notebook), frame, label);

}

void close_option ()
{
  open_windows.Preference_b=FALSE;
  new_conf(); /* initialise le fichier de conf */
}

void option_menu ()
{
  GtkWidget *window;
  GtkWidget *button;
  GtkWidget *pixmap;
  GdkPixmap *gdk_pixmap;
  GdkBitmap *mask;
  GdkColor transparent;
  GtkWidget *hbox;
  GtkWidget *table;
  GtkWidget *notebook;
  GtkWidget *label;
  
  window = gtk_window_new (GTK_WINDOW_DIALOG);
  
  gtk_signal_connect (GTK_OBJECT (window), 
		      "delete_event", 
		      GTK_SIGNAL_FUNC (close_option), 
		      NULL);
  
  gtk_signal_connect (GTK_OBJECT (window), 
		      "delete_event", 
		      GTK_SIGNAL_FUNC (gtk_widget_destroy), 
		      window);
  
  gtk_window_set_policy ( GTK_WINDOW ( window  ) , 0, 0, 0);
  gtk_window_set_position ( GTK_WINDOW( window ),  GTK_WIN_POS_MOUSE);
  gtk_window_set_title ( GTK_WINDOW( window ), "Menu d'options" );
  gtk_container_set_border_width (GTK_CONTAINER (window), 3);
  
  table = gtk_table_new(2,6,FALSE);
  gtk_container_add (GTK_CONTAINER (window), table);

  notebook = gtk_notebook_new ();
  gtk_notebook_set_tab_pos (GTK_NOTEBOOK (notebook), GTK_POS_TOP);
  gtk_table_attach_defaults(GTK_TABLE(table), notebook, 0,6,0,1);
  gtk_widget_show(notebook);
  
  window_gestion( GTK_NOTEBOOK (notebook));
  option_general( GTK_NOTEBOOK (notebook));
   
  gtk_notebook_set_page (GTK_NOTEBOOK(notebook), 0);
  
  button = gtk_button_new ();
  gtk_signal_connect_object (GTK_OBJECT (button), 
			     "clicked", 
			     GTK_SIGNAL_FUNC (close_option),
			     NULL);
  gtk_signal_connect_object (GTK_OBJECT (button), 
			     "clicked", 
			     GTK_SIGNAL_FUNC (gtk_widget_destroy), 
			     GTK_OBJECT(window));
  hbox = gtk_hbox_new(FALSE, 1);
  gtk_container_add(GTK_CONTAINER(button), hbox);
  gtk_widget_show(hbox);
  gdk_pixmap = gdk_pixmap_create_from_xpm_d(window->window, &mask, 
					    &transparent, quitter_xpm);
  pixmap = gtk_pixmap_new(gdk_pixmap, mask);
  gdk_pixmap_unref(gdk_pixmap);
  gtk_box_pack_start(GTK_BOX(hbox), pixmap, 1, 0, 4);
  gtk_widget_show(pixmap);
  label = gtk_label_new("QUITTER");
  gtk_box_pack_start(GTK_BOX(hbox), label, 1, 0, 0);
  gtk_widget_show(label);
  gtk_table_attach (GTK_TABLE(table), 
		    button, 5,6,1,2, 
		    GTK_SHRINK, 
		    GTK_SHRINK, 5,5);
  gtk_widget_show(button);
    
  gtk_widget_show(table);
  gtk_widget_show(window);
  
  if ( open_windows.Preference_b == TRUE )
    gtk_widget_destroy(window);
  open_windows.Preference_b=TRUE;
}
