typedef struct 
{
  VECT3D *MinCorner;
  VECT3D *MaxCorner;
} coord_dnd;

GSList		*AddTriangleToMesh(GSList *list, T_face *face);
T_face		*make_face(VECT3D *A, VECT3D *B, VECT3D *C);
T_face		*ReadTriangleOfMesh(GSList *list, int index_face);
void		specify_index(ObjectBox *bb, int A, int B, int C, int i);
T_obj		*make_MeshTriangleBox(VECT3D *P1, VECT3D *P2);
T_obj		*make_MeshTriangleSphere(VECT3D *center, float radius);
T_obj		*make_MeshTriangleCone(VECT3D *c1, float r1, int is_openC1, 
				      VECT3D *c2, float r2, int is_openC2,
				      int is_double_face);
T_obj		*make_MeshTriangleTorus(VECT3D *center, float radius, float vradius);
T_obj		*make_MeshTrianglePlane(VECT3D *B1, VECT3D *P);
T_obj		*make_MeshTriangleSor(GList *list, int nb_pt);
