#include <gtk/gtk.h>
#include <stdio.h>
#include "tube.xpm"
#include "../../headers.h"

int plug_index;


GtkWidget *create_pixmap(GtkWidget *parent)
{
  GtkWidget *pixmapwid;
  GdkPixmap *pixmap;
  GdkBitmap *mask;
  GtkStyle *style;

  style = gtk_widget_get_style(parent);
  pixmap = gdk_pixmap_create_from_xpm_d(parent->window, &mask, 
					&style->bg[GTK_STATE_NORMAL], 
					(gchar **)tube_xpm);
  pixmapwid = gtk_pixmap_new(pixmap, mask);

  return pixmapwid;
}

void on_click(GtkWidget *widget,gpointer data)
{
  ;
}

GtkWidget *create()
{
  GtkWidget *button;
  GtkWidget *pixmap;

  button = gtk_toggle_button_new();
  pixmap = create_pixmap(button);
  gtk_widget_show(pixmap);
  gtk_container_add(GTK_CONTAINER(button),pixmap);
  return button;
}
