#include <stdlib.h>
#include <glib.h>
#include <tree.h>
#include <parser.h>
#include "../types/tree.h"
#include "scene.h"
#include "utils.h"
#include "object.h"

xmlNodePtr xml_texture_add(xmlNodePtr tree, char *name)
{
  xmlNodePtr subtree;
  
  subtree=xmlNewNode(NULL,"TEXTURE");
  
  xmlSetProp(subtree,"value", name);
   
  xmlAddChild(tree,subtree);

  return subtree;
}

char *xml_texture_get_name(xmlNodePtr tree)
{
  return xmlGetProp(tree,"name");
}

xmlNodePtr xml_texture_set_name(xmlNodePtr tree, char *name)
{
  xmlSetProp(tree,"name",name);
  return tree;
}










