#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <GL/gl.h>
#include <GL/glu.h>
#include <gtkgl/gtkglarea.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gtkeditor.h>
#include <math.h>
#include <tgmath.h>
#include <ctype.h>
#ifndef MLTYPES
#define MLTYPES
#include "mltypes.h"
#endif
#include "mlobject.h"
#include "view_cam.h"
#include "lightbar.h"

/* Basic includes */
#include <string.h>
#include <strings.h>
/* ELF loading library */
#include <dlfcn.h>
/* POSIX library to parse directories */
#include <dirent.h>

#define Version_modlight "Modlight"
gchar	*default_pwd;
gchar	*Nom_doc;


int	is_present_obj;
/* Maximum of interface plugins */
#define MAX_FUNC 32
/* Plugins directory, without separators */
#define PLUG_DIR	"plugins"
#define COREPLUG_DIR	"core_plugins"

#define BTN_SIZE 32

/* Arrays that contains handles, creations func and callbacks (and that's all for the moment) */
struct		plugins
{
  int		index;
  int		nb_plugs;
  void		*handle[MAX_FUNC];
  GtkWidget	*(*create[MAX_FUNC])();
  void		(*on_click[MAX_FUNC])();
  gchar		name[MAX_FUNC][64];
};

struct		core_plugins
{
  void		*handle;
  gboolean	(*on_press)(GtkWidget *window, GdkEventButton *event, coord *point);
  gboolean	(*on_release)(GtkWidget *window, GdkEventButton *event, coord *point);
};
#include "global.h"
#include "mlApropos.h"
#include "mlMessage.h"
#include "make_properties.h"
#include "basic_test.h"
#include "mlFileselection.h"
#include "mlGestionfenetre.h"
#include "PovEdit/file_editor.h"
#include "pov2xml/xmlight.h"
#include "mlItemfactory.h"
#include "mlMenuoption.h"
#include "mlNouveau.h"
#include "mlStartmod.h"
#include "mlWindowsopenning.h"
#include "mlMain.h"
#include "callbacks.h"
#include "interface.h"
#include "so.h"
#include "mlConfuser.h"
#include "mlInit_close_main.h"
#include "matrix.h"
#include "mlManageMemory.h"
#include "mlprimitive.h"
#include "view_YZ.h"
#include "view_XY.h"
#include "view_XZ.h"
#include "object_prop.h"
#include "dialog_box.h"
#include "model.h"
#include "povfunc.h"
#include "build_scene.h"
