#include "headers.h"

static GtkItemFactoryEntry menu_items[] = {
  { "/_File",			  NULL,         NULL,           0, "<Branch>" },
  { "/File/_New...",		"<control>N", nouveau ,		(int)"*" ,  NULL },
  { "/File/_Open...",		"<control>O", selection ,	0, NULL },
  { "/File/_Save",		"<control>S", save_xmlfile,		0, NULL },
  { "/File/Save _as...",	"<control>U", NULL,		0, NULL },
  { "/File/sep1",		NULL,         NULL,		0, "<Separator>" },
  { "/File/Pov_Edit",		"<control>E", StartPovEdit,	0, NULL},
  { "/File/_Preferences...",	"<control>P", option_menu,	0, NULL },
  { "/File/sep2",		NULL,         NULL,		0, "<Separator>" },
  { "/File/_Quit",		"<control>Q", main_close_end,	0, NULL },
  { "/_?",			NULL,         NULL,		0, "<LastBranch>" },
  { "/_?/_About...",		NULL,         apropos,		0, NULL }, 
};

void get_main_menu( GtkWidget  *Fenetre, GtkWidget **menubar )
{
  GtkItemFactory *item_factory;
  GtkAccelGroup *accel_group;
  gint nmenu_items = sizeof (menu_items) / sizeof (menu_items[0]);
  
  accel_group = gtk_accel_group_new ();
  item_factory = gtk_item_factory_new (GTK_TYPE_MENU_BAR, "<main>",  accel_group);
  gtk_item_factory_create_items (item_factory, nmenu_items, menu_items, NULL);
  gtk_accel_group_attach (accel_group, GTK_OBJECT (Fenetre));
  if (menubar)
    *menubar = gtk_item_factory_get_widget (item_factory, "<main>");
}


