#include "headers.h"
#include "xpm/yes.xpm"
#include "xpm/no.xpm"
#include "xpm/over_write.xpm"
#include "xpm/warning.xpm"


void overwrite ( GtkWidget *w ,const char *path_overw ) 
{
  FILE *fp;
  fp = fopen( path_overw, "w");
  /* inserer ici toutes les initialisations (il serait cool de creer un fonction d'init 
   * pour cette fonction et la fonction init_new qui requere la meme fonction d'init */
  fclose(fp);
}

void close_new ()
{
  open_windows.Nouveau_b=FALSE;
}

void already_present ( const char *path)
{
  GtkWidget *Fenetre;
  GtkWidget *table;
  GtkWidget *pixmap;
  GdkPixmap *gdk_pixmap;
  GdkBitmap *mask;
  GtkWidget *bouton;
  GdkColor transparent;
  GtkWidget *label;
  GtkWidget *main_hbox;
  

  Fenetre = gtk_window_new (GTK_WINDOW_DIALOG);
  
  gtk_signal_connect (GTK_OBJECT (Fenetre), "destroy", 
		      GTK_SIGNAL_FUNC(close_new), 
		      GTK_OBJECT(Fenetre)); 
  
  gtk_signal_connect_object (GTK_OBJECT (Fenetre), 
			     "destroy", 
			     GTK_SIGNAL_FUNC (gtk_widget_destroy), 
			     GTK_OBJECT (Fenetre));
  
  gtk_window_set_title (GTK_WINDOW (Fenetre), "Erreur  la cration");
  gtk_window_set_position ( GTK_WINDOW( Fenetre ),  GTK_WIN_POS_CENTER);
  gtk_window_set_policy ( GTK_WINDOW ( Fenetre ) , 0, 0, 0);
  table = gtk_table_new ( 2, 3, FALSE);
  gtk_container_add (GTK_CONTAINER (Fenetre), table);

  gdk_pixmap = gdk_pixmap_create_from_xpm_d(Fenetre->window, &mask, &transparent, warning);
  pixmap = gtk_pixmap_new(gdk_pixmap, mask);
  gdk_pixmap_unref(gdk_pixmap);
  gtk_widget_show(pixmap);
  gtk_table_attach (GTK_TABLE(table), pixmap, 0, 1, 0, 1 , GTK_SHRINK, GTK_SHRINK, 5 , 8 );

  label = gtk_label_new (g_strconcat( Nom_doc,".mlo", " xiste djas !", NULL));
  gtk_table_attach (GTK_TABLE(table), label, 1, 3, 0, 1 , GTK_SHRINK, GTK_SHRINK, 1 , 1 );
  gtk_widget_show (label);

  bouton = gtk_button_new();
  gtk_signal_connect (GTK_OBJECT (bouton), 
		      "clicked", 
		      GTK_SIGNAL_FUNC(overwrite), 
		      (gpointer)path);
  
  gtk_signal_connect (GTK_OBJECT (bouton), 
		      "clicked", 
		      GTK_SIGNAL_FUNC(close_new), 
		      Fenetre);
  
  gtk_signal_connect_object (GTK_OBJECT (bouton), 
			     "clicked", 
			     (GtkSignalFunc) gtk_widget_destroy, 
			     GTK_OBJECT (Fenetre));
  
  main_hbox = gtk_hbox_new(FALSE, 1);
  gtk_container_add(GTK_CONTAINER(bouton), main_hbox);
  gtk_container_set_border_width(GTK_CONTAINER(main_hbox), 0 );
  gtk_widget_show(main_hbox);
  gdk_pixmap = gdk_pixmap_create_from_xpm_d(Fenetre->window, &mask, &transparent, over_write);
  pixmap = gtk_pixmap_new(gdk_pixmap, mask);
  gdk_pixmap_unref(gdk_pixmap);
  gtk_box_pack_start(GTK_BOX(main_hbox), pixmap, 1, 0, 4);
  gtk_widget_show(pixmap);
  label = gtk_label_new("REECRIRE");
  gtk_box_pack_start(GTK_BOX(main_hbox), label, 1, 0, 0);
  gtk_widget_show(label);
  gtk_widget_show(bouton);
  gtk_table_attach (GTK_TABLE(table), bouton, 1, 2, 1, 2 , GTK_SHRINK, GTK_SHRINK, 5 , 8 );

  bouton = gtk_button_new();
  gtk_signal_connect (GTK_OBJECT (bouton), 
		      "clicked", GTK_SIGNAL_FUNC(nouveau), 
		      (gpointer)Nom_doc);
  
  gtk_signal_connect_object (GTK_OBJECT (bouton), 
			     "clicked", 
			     (GtkSignalFunc) gtk_widget_destroy, 
			     GTK_OBJECT (Fenetre));
  
  main_hbox = gtk_hbox_new(FALSE, 1);
  gtk_container_add(GTK_CONTAINER(bouton), main_hbox);
  gtk_container_set_border_width(GTK_CONTAINER(main_hbox), 0 );
  gtk_widget_show(main_hbox);
  gdk_pixmap = gdk_pixmap_create_from_xpm_d(Fenetre->window, &mask, &transparent, no);
  pixmap = gtk_pixmap_new(gdk_pixmap, mask);
  gdk_pixmap_unref(gdk_pixmap);
  gtk_box_pack_start(GTK_BOX(main_hbox), pixmap, 1, 0, 4);
  gtk_widget_show(pixmap);
  label = gtk_label_new("ANNULLER");
  gtk_box_pack_start(GTK_BOX(main_hbox), label, 1, 0, 0);
  gtk_widget_show(label);
  gtk_widget_show(bouton);
  gtk_table_attach (GTK_TABLE(table), bouton, 2, 3, 1, 2 , GTK_SHRINK, GTK_SHRINK, 5 , 8 );

  gtk_widget_show(table);
  gtk_widget_show_all (Fenetre);
}

void init_new ( GtkObject *text)  /* fonction d'initilasition */
{
  FILE *fp;
  gchar *path;

  Nom_doc=gtk_editable_get_chars ( GTK_EDITABLE (text), 0, -1);
  (const char *)path=g_strconcat( default_pwd, Nom_doc,".mlo", NULL);
  fp = fopen( path , "r");
  if (fp != NULL)
    {
      open_windows.Nouveau_b=TRUE;
      already_present( path );
    }
  else
    {
      fp = fopen( path , "w");
      /* inserer ici toutes les initialisations */
       fclose(fp);
    }
}

void nouveau ( GtkWidget *Fenetre, const char *text_default )
{

  GtkWidget *fenetre;
  GtkWidget *table;
  GtkWidget *main_hbox;
  GtkWidget *text;
  GtkWidget *pixmap;
  GtkWidget *label;
  GdkPixmap *gdk_pixmap;
  GdkBitmap *mask;
  GtkWidget *bouton;
  GdkColor transparent;
  GdkFont *font;
  
  font=gdk_font_load("-urw-helvetica narrow-medium-r-condensed--17-160-75-75-p-74-iso8859-1");

  fenetre = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_signal_connect (GTK_OBJECT (fenetre), 
		      "destroy", (GtkSignalFunc) close_new, 
		      GTK_OBJECT (fenetre));
  
  gtk_signal_connect (GTK_OBJECT (fenetre), 
		      "destroy", (GtkSignalFunc) gtk_widget_destroy, 
		      GTK_OBJECT (fenetre));
  
  gtk_window_set_title (GTK_WINDOW (fenetre), "Nouveau fichier");
  gtk_window_set_position ( GTK_WINDOW( fenetre ),  GTK_WIN_POS_CENTER);
  gtk_window_set_policy ( GTK_WINDOW ( fenetre ) , 0, 0, 0);

  table = gtk_table_new ( 2, 4, FALSE);
  gtk_container_add (GTK_CONTAINER (fenetre), table);

  label = gtk_label_new ("Entrer le nom du fichier:");
  gtk_table_attach (GTK_TABLE(table), label, 0, 1, 0, 1 , GTK_SHRINK, GTK_SHRINK, 1 , 1 );
  gtk_widget_show (label);
  
  text = gtk_entry_new ();
  gtk_entry_set_text ( GTK_ENTRY (text), text_default );
  gtk_table_attach (GTK_TABLE(table), text, 1, 4, 0, 1 , GTK_SHRINK, GTK_SHRINK, 15 , 2 );
  gtk_widget_show (text);

  bouton = gtk_button_new();
  gtk_signal_connect_object (GTK_OBJECT (bouton), 
			     "clicked", 
			     GTK_SIGNAL_FUNC (init_new), 
			     GTK_OBJECT(text));
  
  gtk_signal_connect_object (GTK_OBJECT (bouton), 
			     "clicked", (GtkSignalFunc) gtk_widget_destroy, 
			     GTK_OBJECT (fenetre));

  main_hbox = gtk_hbox_new(FALSE, 1);
  gtk_container_add(GTK_CONTAINER(bouton), main_hbox);
  gtk_container_set_border_width(GTK_CONTAINER(main_hbox), 0 );
  gtk_widget_show(main_hbox);
  gdk_pixmap = gdk_pixmap_create_from_xpm_d(fenetre->window, &mask, &transparent, yes);
  pixmap = gtk_pixmap_new(gdk_pixmap, mask);
  gdk_pixmap_unref(gdk_pixmap);
  gtk_box_pack_start(GTK_BOX(main_hbox), pixmap, 1, 0, 4);
  gtk_widget_show(pixmap);
  label = gtk_label_new("OK");
  gtk_box_pack_start(GTK_BOX(main_hbox), label, 1, 0, 0);
  gtk_widget_show(label);
  gtk_widget_show(bouton);
  gtk_table_attach (GTK_TABLE(table), bouton, 1, 2, 1, 2 , GTK_SHRINK, GTK_SHRINK, 5 , 8 );

  bouton = gtk_button_new();
  gtk_signal_connect_object (GTK_OBJECT (bouton), 
			     "clicked", 
			     (GtkSignalFunc) close_new, 
			     GTK_OBJECT (fenetre));

  gtk_signal_connect_object (GTK_OBJECT (bouton), 
			     "clicked", 
			     (GtkSignalFunc) gtk_widget_destroy, 
			     GTK_OBJECT (fenetre));

  main_hbox = gtk_hbox_new(FALSE, 1);
  gtk_container_add(GTK_CONTAINER(bouton), main_hbox);
  gtk_container_set_border_width(GTK_CONTAINER(main_hbox), 0 );
  gtk_widget_show(main_hbox);
  gdk_pixmap = gdk_pixmap_create_from_xpm_d(fenetre->window, &mask, &transparent, no);
  pixmap = gtk_pixmap_new(gdk_pixmap, mask);
  gdk_pixmap_unref(gdk_pixmap);
  gtk_box_pack_start(GTK_BOX(main_hbox), pixmap, 1, 0, 4);
  gtk_widget_show(pixmap);
  label = gtk_label_new("ANNULLER");
  gtk_box_pack_start(GTK_BOX(main_hbox), label, 1, 0, 0);
  gtk_widget_show(label);
  gtk_widget_show(bouton);
  gtk_table_attach (GTK_TABLE(table), bouton, 2, 3, 1, 2 , GTK_SHRINK, GTK_SHRINK, 5 , 8 );

  gtk_widget_show(table);
  gtk_widget_show_all (fenetre);

  if ( open_windows.Nouveau_b )
      gtk_widget_destroy(fenetre);
  open_windows.Nouveau_b=TRUE;
}
