#include "headers.h"

extern struct windows_view_struct windows_view;

void  windows_openning( int value)
{
  
  switch ( value )
    {
    case 1:
      if (open_windows.right_b)
	  construct (value);
      else
	gtk_widget_destroy (windows_view.right);
      break;
    case 2:
      if (open_windows.face_b)
	  construct (value);
      else
	gtk_widget_destroy (windows_view.face);
      break;
    case 3:
      if (open_windows.over_b)
	  construct (value);
      else
	gtk_widget_destroy (windows_view.over);
      break;
    case 4:
      if (open_windows.vu3d_b)
	construct (value);
      else
	gtk_widget_destroy (windows_view.vu3d);
    }

}

void close_construct_right ()
{
  open_windows.right_b=FALSE;
  gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (windows_view.check_r),0);
  gtk_widget_destroy(windows_view.right);
}

void close_construct_face ()
{
  open_windows.face_b=FALSE;
  gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (windows_view.check_f) , 0);
  gtk_widget_destroy(windows_view.face);
}

void close_construct_over(void)
{
  open_windows.over_b = FALSE;
  gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (windows_view.check_o) , 0);
  gtk_widget_destroy(windows_view.over);
}

void close_construct_vu3d(void)
{
  open_windows.vu3d_b=FALSE;
  gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (windows_view.check_d) , 0);
  gtk_widget_destroy(windows_view.vu3d);
}

void construct(int vue)
{
  int *click_count;
  switch (vue)
    {
    case 1:
      WindowYZ_new();
      break;
    case 2:
      WindowXY_new();
      break;
    case 3:
      WindowXZ_new();
      break;
    case 4:
      windows_view.vu3d = gtk_window_new (GTK_WINDOW_TOPLEVEL);
      gtk_object_set_data(GTK_OBJECT(windows_view.vu3d),"count",(gpointer)&click_count);
      gtk_signal_connect (GTK_OBJECT (windows_view.vu3d), 
			  "delete_event", 
			  GTK_SIGNAL_FUNC (close_construct_vu3d), 
			  NULL);
      gtk_signal_connect(GTK_OBJECT(windows_view.vu3d),
			 "button-press-event",
			 GTK_SIGNAL_FUNC(core.on_press),
			 (gpointer)&point);
      gtk_signal_connect(GTK_OBJECT(windows_view.vu3d),
			 "button-release-event",
			 GTK_SIGNAL_FUNC(core.on_release),
			 (gpointer)&point);


      gtk_container_set_border_width (GTK_CONTAINER (windows_view.vu3d), 3);
      gtk_window_set_title (GTK_WINDOW(windows_view.vu3d), "Vue 3D");
      show_gtkGL("3D Modelight VIEW", windows_view.vu3d); // init GL

      /*  gtk_widget_set_usize (windows_view.vu3d, 400, 300); */
      gtk_widget_show(windows_view.vu3d);
      break;
    }
}
